(function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(require,module,exports){
var Player = require('./Player.class');
var Utils = require('./Utils');

function Corridor(level, features){
	this.level = null;
	this.description = null;
	this.trap = null;
	this.obstacle = null;
	this.init(level, features);
}

Corridor.ARROWS_TRAP = 'arrows-trap';
Corridor.FLOOR_TRAP = 'floor-trap';
Corridor.FALLING_TRAP = 'falling-trap';
Corridor.BOMB_TRAP = 'bomb-trap';
Corridor.POWDER_TRAP = 'powder-trap';

Corridor.SPIKES_TRAP = 'spikes-trap';
Corridor.CLAMPING_TRAP = 'clamping-trap';
Corridor.CALTROPS_TRAP = 'caltrops-trap';
Corridor.PIT_TRAP = 'pit-trap';

Corridor.FIRE_FIELD = 'fire-field';
Corridor.POISON_FIELD = 'poison-field';
Corridor.SLEEP_FIELD = 'sleep-field';

Corridor.TRAP_DESCRIPTIONS = {};
Corridor.TRAP_DESCRIPTIONS[Corridor.ARROWS_TRAP] = 'Arrows fly from everywhere!';
Corridor.TRAP_DESCRIPTIONS[Corridor.FALLING_TRAP] = 'Rocks fall from the ceiling!';
Corridor.TRAP_DESCRIPTIONS[Corridor.BOMB_TRAP] = 'BOOM! A bomb is set off!';
Corridor.TRAP_DESCRIPTIONS[Corridor.POWDER_TRAP] = 'A cloud of smoke covers the party!';
Corridor.TRAP_DESCRIPTIONS[Corridor.SPIKES_TRAP] = 'You fall into a pit of sharp spikes';
Corridor.TRAP_DESCRIPTIONS[Corridor.CLAMPING_TRAP] = 'You step on a clamping trap';
Corridor.TRAP_DESCRIPTIONS[Corridor.CALTROPS_TRAP] = 'Sharp caltrops are hidden in the floor!';
Corridor.TRAP_DESCRIPTIONS[Corridor.PIT_TRAP] = 'You fall into a pit!';

Corridor.OBSTACLE_DESCRIPTIONS = {};
Corridor.OBSTACLE_DESCRIPTIONS[Corridor.FIRE_FIELD] = 'a red field';
Corridor.OBSTACLE_DESCRIPTIONS[Corridor.POISON_FIELD] = 'a green field';
Corridor.OBSTACLE_DESCRIPTIONS[Corridor.SLEEP_FIELD] = 'a purple field';

Corridor.HALLWAY = 'hallway';
Corridor.TUNNEL = 'tunnel';
Corridor.GAP = 'gap';
Corridor.TIGHT = 'tight';

Corridor.SPECIAL_TYPES = [Corridor.TUNNEL, Corridor.GAP, Corridor.TIGHT];

Corridor.prototype = {
	init: function(level, features){
		this.level = level;
		this.description = features.description;
		this.trap = features.trap;
		this.obstacle = features.obstacle;
	},
	getDescription: function(){
		var description = this.description;
		if (this.obstacle){
			description += ' with '+Corridor.OBSTACLE_DESCRIPTIONS[this.obstacle.type];
		}
		return description;	
	},
	getTrapTriggeredDescription: function(trap){
		return Corridor.TRAP_DESCRIPTIONS[trap.description ? trap.description : trap.type];
	},
	triggerTrap: function(trap){
		this.level.controller.ui.showMessage(this.getTrapTriggeredDescription(trap));
		var party = this.level.controller.party;
		if (trap.multiTarget){
			// Try to hit all players in the Party
			for (var i = 0; i < party.players.length; i++){
				if (party.players[i].evadesTrap()){
					this.level.controller.ui.showMessage(party.players[i].name + ' evades the trap');
				} else {
					this.applyTrapEffect(trap, party.players[i]);
				}
			}
		} else {
			// Pick a single target
			var target = Utils.randomElementOf(party.players);
			if (target.evadesTrap()){
				this.level.controller.ui.showMessage(target.name + ' evades the trap');
			} else {
				this.applyTrapEffect(trap, target);
			}
		}
	},
	triggerTrapOn: function(trap, targets){
		for (var i = 0; i < targets.length; i++){
			this.applyTrapEffect(trap, targets[i]);
		}
	}, 
	applyTrapEffect: function(trap, player){
		// Injuries or direct effects based on type
		switch (trap.type){
			case Corridor.ARROWS_TRAP:
				player.sustainInjury((Utils.chance(50) ? Player.LEFT : Player.RIGHT)+'-'+(Utils.chance(50) ? Player.ARM : Player.LEG));
				break;
			case Corridor.FLOOR_TRAP:
				if (Utils.chance(50)){
					player.sustainInjury((Utils.chance(50) ? Player.LEFT : Player.RIGHT)+'-'+Player.LEG);
				} else {
					player.sustainInjury(Player.RIGHT_LEG);
					player.sustainInjury(Player.LEFT_LEG);
				}
				break;
			break;
			case Corridor.FALLING_TRAP:
				switch (Utils.rand(0,2)){
					case 0:
						player.sustainInjury(Player.RIGHT_ARM);
						break;
					case 1:
						player.sustainInjury(Player.LEFT_ARM);
						break;
					case 2:
						player.applyAilment(Player.UNCONSCIOUS);
						break;
				}
			break;
			case Corridor.BOMB_TRAP:
				var hits = Utils.rand(1,3);
				for (var i = 0; i < hits; i++){
					if (Utils.chance(20)){
						player.applyAilment(Player.UNCONSCIOUS);
					} else {
						player.sustainInjury((Utils.chance(50) ? Player.LEFT : Player.RIGHT)+'-'+(Utils.chance(50) ? Player.ARM : Player.LEG));
					}
				}
			break;
		}
		if (trap.effect){
			player.applyAilment(trap.effect);
		}
	}
}

module.exports = Corridor;
},{"./Player.class":8,"./Utils":15}],2:[function(require,module,exports){
var Corridor = require('./Corridor.class');
var Player = require('./Player.class');
var Utils = require('./Utils');

var CorridorGenerator = {
	generateCorridor: function(level){
		var corridorType = Corridor.HALLWAY;
		if (Utils.chance(20)){
			corridorType = Utils.randomElementOf(Corridor.SPECIAL_TYPES);
		}
		var trap = null;
		if (corridorType === Corridor.HALLWAY && Utils.chance(20)){
			switch (Utils.rand(0,4)){
				case 0:
					var effect = false;
					switch (Utils.rand(0,2)){
						case 0: effect = Player.POISONED; break;						
						case 1: effect = Player.PARALYZED; break;
					}
					trap = {
						type: Corridor.ARROWS_TRAP,
						effect: effect,
						multiTarget: Utils.chance(20),
						slow: Utils.chance(50),
						evadeMessage: 'Players must duck quickly to evade the trap'
					};
					break;
				case 1:
					var description = Utils.randomElementOf([Corridor.SPIKES_TRAP, Corridor.CLAMPING_TRAP, Corridor.CALTROPS_TRAP, Corridor.PIT_TRAP]);
					effect = false;
					if (description === Corridor.CLAMPING_TRAP){
						effect = Player.CLAMPED;
					}
					trap = {
						type: Corridor.FLOOR_TRAP,
						description: description,
						effect: effect,
						multiTarget: description !== Corridor.CLAMPING_TRAP,
						slow: Utils.chance(50),
						evadeMessage: 'Players must jump quickly to evade the trap'
					};
					break;
				case 2:
					trap = {
						type: Corridor.FALLING_TRAP,
						multiTarget: true,
						slow: Utils.chance(50),
						evadeMessage: 'Players must run quickly to the next room to evade the trap'
					};
					break;
				case 3:
					trap = {
						type: Corridor.BOMB_TRAP,
						multiTarget: true
					};
					break;
				case 4:
					var effect = Utils.randomElementOf([Player.BLIND, Player.PARALYZED, Player.ASLEEP, Player.POISONED, Player.MUTE]);
					trap = {
						type: Corridor.POWDER_TRAP,
						effect: effect,
						multiTarget: true,
						slow: Utils.chance(50),
						evadeMessage: 'Players must cover their nose, close their eyes and mouth and crawl quickly to the next room to evade the trap'
					};
					break;
			}
		}
		var obstacle = false;
		if (corridorType === Corridor.HALLWAY && Utils.chance(20)){
			obstacle = {
				type: Utils.randomElementOf([Corridor.FIRE_FIELD, Corridor.POISON_FIELD, Corridor.SLEEP_FIELD]),
				canPassThru: true
			}
		}
		return new Corridor(level, {	
			description: this.getDescription(corridorType),
			type: corridorType,
			trap: trap,
			obstacle: obstacle
		});
	},
	getDescription: function(corridorType){
		// TODO: Spice up descriptions
		switch (corridorType){
			case Corridor.HALLWAY:
				return 'A stone hallway';
			case Corridor.TUNNEL:
				return 'A tunnel';
			case Corridor.GAP:
				return 'A gap you can jump';
			case Corridor.TIGHT:
				return 'A tight opening you can squeeze into'
		}
	}
};

module.exports = CorridorGenerator;
},{"./Corridor.class":1,"./Player.class":8,"./Utils":15}],3:[function(require,module,exports){
var DOM = {
	byId: function(id){
		return document.getElementById(id);
	},
	create: function(type){
		return document.createElement(type);
	},
	onClick: function(element, cb, context){
		if (typeof element === 'string'){
			element = this.byId(element);
		}
		element.addEventListener('click', cb.bind(context));
	},
	val: function(id){
		return this.byId(id).value;
	},
	selectAll: function(query, filter){
		var elements = document.querySelectorAll(query);
		if (filter){
			for (var i = 0; i < elements.length; i++){
				filter(elements[i]);
			}
		}
		return elements;
	}
}
module.exports = DOM;
},{}],4:[function(require,module,exports){
var Level = require('./Level.class');
var RoomGenerator = require('./RoomGenerator');
var CorridorGenerator = require('./CorridorGenerator');
var Utils = require('./Utils');

var DungeonGenerator = {
	potentialCorridors: null,
	level: null,
	generateLevel: function(specs, controller){
		this.controller = controller;
		this.potentialCorridors = [];
		var w = specs.w;
		var h = specs.h;
		var depth = specs.depth;
		this.level = new Level(w, h, depth, controller);
		switch (specs.roomDensity){
			case 'hi':
				specs.roomDensity = 0.8;
				break;
			case 'mid':
				specs.roomDensity = 0.6;
				break;
			case 'low':
				specs.roomDensity = 0.4;
				break;
			case 'increasing':
				specs.roomDensity = 0.3 + depth * 0.05;
				break;
		}
		if (specs.roomDensity > 0.9)
			specs.roomDensity = 0.9;
		var allRooms = Math.floor(w * h * specs.roomDensity) - 1;
		specs.sections = 3;
		for (var i = 0; i < specs.sections; i++){
			var success = this._generateSection({
				starting: i == 0,
				ending: i == specs.sections - 1,
				rooms: Math.ceil(allRooms / specs.sections)
			},specs,
			depth);
			if (!success){
				return false;
			}
		}
		return this.level;
	},
	_generateSection: function (sectionSpecs, specs, depth){
		var remainingRooms = sectionSpecs.rooms;
		if (sectionSpecs.starting){
			var startingRoom = RoomGenerator.generateRoom(this.controller.scenario, this.level, {addStairsUp: depth > 1, isEntrance: true});
			this.placeRoom(null, specs.startingLocation.x, specs.startingLocation.y, startingRoom);
		}
		while (remainingRooms > 0){
			var potentialCorridor = Utils.pullRandomElementOf(this.potentialCorridors);
			if (!potentialCorridor){
				//Whoops! we hit a dead end :|
				return false;
			}
			var existingRoom = this.level.getRoomAt(potentialCorridor.toX, potentialCorridor.toY);
			if (existingRoom){
				continue;
			}
			remainingRooms--;
			var specs = {};
			if (remainingRooms == 0){
				if (sectionSpecs.ending){
					if (depth == 8){
						specs.addWinArtifact = true;
					} else {
						specs.addStairsDown = true;
					}
					specs.isExit = true;
					specs.gmTips = this.controller.scenario.endRooms[depth];
				} else {
					// End of section, clear almost all corridors
					var survivingCorridor = Utils.pullRandomElementOf(this.potentialCorridors);
					this.potentialCorridors = [];
					this.potentialCorridors.push(survivingCorridor);
				}
			} else {
				specs.addFountain = Utils.chance(10);
			}
			var newRoom = RoomGenerator.generateRoom(this.controller.scenario, this.level, specs);
			var corridor = CorridorGenerator.generateCorridor(this.level);
			this.placeRoom(potentialCorridor.room, potentialCorridor.toX, potentialCorridor.toY, newRoom, corridor);
		}
		return true;
	},
	placeRoom: function(fromRoom, x, y, toRoom, corridor){
		var vector = false;
		this.level.placeRoom(fromRoom, x, y, toRoom, corridor);
		if (fromRoom){
			vector = {
				x: fromRoom.x - x,
				y: fromRoom.y - y
			}
		}

		this._checkAndPlacePotentialCorridors(vector, x, y, 0, -1, toRoom);
		this._checkAndPlacePotentialCorridors(vector, x, y, 0, 1, toRoom);
		this._checkAndPlacePotentialCorridors(vector, x, y, 1, 0, toRoom);
		this._checkAndPlacePotentialCorridors(vector, x, y, -1, 0, toRoom);

	}, 
	_checkAndPlacePotentialCorridors: function(vector, x, y, dx, dy, room){
		if (!vector || vector.x != dx || vector.y != dy){
			if (this.level.isValidRoomLocation(x + dx, y + dy) && !this.level.getRoomAt(x + dx, y + dy)){
				this.potentialCorridors.push(
					{
						toX: x + dx,
						toY: y + dy,
						room: room
					}
				);
			}
		}
	}
};

module.exports = DungeonGenerator;

},{"./CorridorGenerator":2,"./Level.class":5,"./RoomGenerator":10,"./Utils":15}],5:[function(require,module,exports){
var Utils = require('./Utils');

function Level(w, h, depth, controller){
	this.controller = controller;
	this.map = null;
	this.rooms = null;
	this.init(w, h, depth);
}

Level.prototype = {
	init: function(w, h, depth){
		this.depth = depth;
		this.map = [];
		this.rooms = [];
		for (var x = 0; x < w; x++){
			this.map[x] = [];
			for (var y = 0; y < h; y++){
				this.map[x][y] = null;
			}
		}
	},
	placeRoom: function(fromRoom, x, y, room, corridor){
		room.locate(x,y);
		this.map[x][y] = room;
		this.rooms.push(room);
		if (fromRoom){
			fromRoom.corridors[Utils.getDirection(fromRoom, room)] = corridor;
			room.corridors[Utils.getDirection(room, fromRoom)] = corridor;
		}
	},
	getRoom: function(location){
		return this.map[location.x][location.y];
	},
	getRoomAt: function(x, y){
		if (!this.isValidRoomLocation(x,y))
			return false;
		return this.map[x][y];
	},
	isValidRoomLocation: function(x, y){
		return x >= 0 && y >= 0 && x < this.map.length && y < this.map[0].length;
	}
}

module.exports = Level;
},{"./Utils":15}],6:[function(require,module,exports){
require('./scenarios/Basic');
require('./dungeons/Basic');

module.exports = {
	getScenario: function(id){
		return require('./scenarios/'+id);
	},
	getDungeon: function(id){
		return require('./dungeons/'+id);
	}
};
},{"./dungeons/Basic":17,"./scenarios/Basic":18}],7:[function(require,module,exports){
var Utils = require('./Utils');
var Player = require('./Player.class');
var Corridor = require('./Corridor.class');

function Party(specs, controller){
	this.controller = controller;
	this.players = [];
	this.items = [];
	for (var i = 0; i < specs.players.length; i++){
		specs.players[i].number = i + 1;
		this.players.push(new Player(specs.players[i], this));
	}
	this.location = {
		x: null,
		y: null
	};
	this.level = null;
}

Party.prototype = {
	locate: function(x, y){
		this.location.x = x;
		this.location.y = y;
	},
	setLevel: function(level){
		this.level = level;
	},
	getCurrentRoom: function(){
		return this.level.getRoom(this.location);
	},
	addItem: function(item){
		this.items.push(item);
	},
	removeItem: function(item){
		for (var i = 0; i < this.items.length; i++){
			if (this.items[i] == item){
				this.items.splice(i, 1);
				return;
			}
		}
	},
	move: function(dx, dy){
		var direction = Utils.getDirection(this.location, {x: this.location.x+dx, y: this.location.y+dy})
		var corridor = this.getCurrentRoom().corridors[direction];
		if (!corridor){
			this.controller.ui.showMessage('You can\'t go there.');
			return;
		}
		var party = this;
		var controller = this.controller;
		if (corridor.obstacle){
			switch (corridor.obstacle.type){
				case Corridor.FIRE_FIELD:
					this.controller.ui.showMessage('As you walk through the field, you are engulfed in fire!');
					this.takeDamage(3);
					break;
				case Corridor.POISON_FIELD:
					this.controller.ui.showMessage('As you walk through the field, you are poisoned!');
					this.applyAilment(Player.POISONED);
					break;
				case Corridor.SLEEP_FIELD:
					this.controller.ui.showMessage('As you walk through the field, you fall asleep.');
					this.applyAilment(Player.ASLEEP);
					break;
			}
		}
		if (!corridor.obstacle || corridor.obstacle.canPassThru){
			if (corridor.trap){
				if (corridor.trap.slow){
					var html = '<p>'+corridor.getTrapTriggeredDescription(corridor.trap)+'</p>';
					html += '<p class = "gmTip">'+corridor.trap.evadeMessage+'.</p>';
					html += '<p>Select the party members who couldn\'t evade the trap.</p>';
					controller.ui.setSelectTargetsMessage(html);
					this.controller.pickTargetCallback = function(targets){
						if (targets.length == 0){
							controller.ui.showMessage('All party members evade the trap.');
						} else {
							corridor.triggerTrapOn(corridor.trap, targets);
						}
						corridor.trap = false;
						controller.setInputStatus(controller.MOVE);
						party._doMove(dx, dy, true);
					};
					this.controller.setInputStatus(this.controller.PICK_TARGET);
					return; // Party doesn't move
				} else {
					corridor.triggerTrap(corridor.trap);
					corridor.trap = false;
				}
			}
		}
		this._doMove(dx,dy,true);
	},
	_doMove: function(dx, dy, physically){
		this.location.x += dx;
		this.location.y += dy;
		this.passTurn();
		if (this.getCurrentRoom().spawnEnemies){
			var enemyParty = this.controller.staff.selectEnemyParty();
			this.getCurrentRoom().enemies = enemyParty;
			this.controller.setInputStatus(this.controller.COMBAT);
			this.controller.ui.playMusic('combat');
		} else {
			this.controller.ui.setMovementButtons();
			this.controller.ui.updateRoomData(this.getCurrentRoom());
		}
	},
	passTurn: function(){
		for (var i = 0; i < this.players.length; i++){
			this.players[i].passTurn();
		}
	},
	getPlayerByNumber: function(number){
		for (var i = 0; i < this.players.length; i++){
			if (this.players[i].number == number)
				return this.players[i];
		}
	},
	cureAilment: function(ailment){
		for (var i = 0; i < this.players.length; i++){
			this.players[i].cureAilment(ailment);
		}	
	},
	takeDamage: function(damage){
		for (var i = 0; i < this.players.length; i++){
			this.players[i].takeDamage(damage);
		}
	},
	checkGameOver: function(){
		for (var i = 0; i < this.players.length; i++){
			if (this.players[i].hitPoints.current > 0)
				return;
		}
		this.controller.ui.playMusic('death');
		this.controller.ui.showMessage('Game Over...');
	},
	applyAilment: function(ailment, turns){
		for (var i = 0; i < this.players.length; i++){
			this.players[i].applyAilment(ailment, turns);
		}
	},
	useItem: function(item, player){
		player[item.effect](item.param);
		this.removeItem(item);
	},
	blink: function(direction){
		var vector = Utils.getVector(direction);
		var room = this.level.getRoomAt(this.location.x + vector.x, this.location.y + vector.y);
		if (room){
			this.controller.ui.showMessage('The party teleports.');
			this._doMove(vector.x, vector.y, false);
		} else {
			this.controller.ui.showMessage('You can\'t go there.');
		}
	}
}

module.exports = Party;
},{"./Corridor.class":1,"./Player.class":8,"./Utils":15}],8:[function(require,module,exports){
var Utils = require('./Utils');
var Stat = require('./Stat.class'); 

function Player(specs, party){
	this.party = party;
	this.injuredMap = {}
	this.injuredMap[Player.LEFT_ARM] = false;
	this.injuredMap[Player.RIGHT_ARM] = false;
	this.injuredMap[Player.LEFT_LEG] = false;
	this.injuredMap[Player.RIGHT_LEG] = false;
	this.statusAilments = [];
	this.name = specs.name;
	this.role = specs.role;
	this.job = party.controller.scenario.getJob(specs.job);
	this.number = specs.number;
	this.hitPoints = new Stat(this.job.str);
	this.magicPoints = new Stat(this.job.magic);
};

Player.LEFT = 'left';
Player.RIGHT = 'right';
Player.ARM = 'arm';
Player.LEG = 'leg';

Player.TORSO = 'torso';
Player.LEFT_LEG = 'left-leg';
Player.RIGHT_LEG = 'right-leg';
Player.LEFT_ARM = 'left-arm';
Player.RIGHT_ARM = 'right-arm';
Player.UNCONSCIOUS= 'unconscious';
Player.BLIND = 'blind';
Player.PARALYZED = 'paralyzed';
Player.ASLEEP = 'asleep';
Player.POISONED = 'poisoned';
Player.MUTE = 'mute';
Player.CLAMPED = 'clamped';

Player.BODY_PART_NAMES = {};
Player.BODY_PART_NAMES[Player.TORSO] = 'Torso';
Player.BODY_PART_NAMES[Player.LEFT_ARM] = 'Left Arm';
Player.BODY_PART_NAMES[Player.RIGHT_ARM] = 'Right Arm';
Player.BODY_PART_NAMES[Player.LEFT_LEG] = 'Left Leg';
Player.BODY_PART_NAMES[Player.RIGHT_LEG] = 'Right Leg';

Player.AILMENT_EFFECTS = {};
Player.AILMENT_EFFECTS[Player.UNCONSCIOUS] = 'falls unconscious';
Player.AILMENT_EFFECTS[Player.BLIND] = 'cannot see';
Player.AILMENT_EFFECTS[Player.PARALYZED] = 'is paralyzed';
Player.AILMENT_EFFECTS[Player.ASLEEP] = 'falls asleep';
Player.AILMENT_EFFECTS[Player.POISONED] = 'is poisoned';
Player.AILMENT_EFFECTS[Player.MUTE] = 'cannot speak';
Player.AILMENT_EFFECTS[Player.CLAMPED] = 'is immobilized in the spot';

Player.AILMENT_RECOVERY = {};
Player.AILMENT_RECOVERY[Player.UNCONSCIOUS] = 'recovers consciousness';
Player.AILMENT_RECOVERY[Player.BLIND] = 'can see again';
Player.AILMENT_RECOVERY[Player.PARALYZED] = 'can move again';
Player.AILMENT_RECOVERY[Player.ASLEEP] = 'wakes up';
Player.AILMENT_RECOVERY[Player.POISONED] = 'is no longer poisoned';
Player.AILMENT_RECOVERY[Player.MUTE] = 'can speak again';
Player.AILMENT_RECOVERY[Player.CLAMPED] = 'frees from the trap';

Player.AILMENT_NAMES = {};
Player.AILMENT_NAMES[Player.UNCONSCIOUS] = 'Unconscious';
Player.AILMENT_NAMES[Player.BLIND] = 'Blind';
Player.AILMENT_NAMES[Player.PARALYZED] = 'Paralyzed';
Player.AILMENT_NAMES[Player.ASLEEP] = 'Asleep';
Player.AILMENT_NAMES[Player.POISONED] = 'Poisoned';
Player.AILMENT_NAMES[Player.MUTE] = 'Mute';
Player.AILMENT_NAMES[Player.CLAMPED] = 'Clamped';

Player.AILMENT_CODES = {};
Player.AILMENT_CODES[Player.UNCONSCIOUS] = 'UN';
Player.AILMENT_CODES[Player.BLIND] = 'BL';
Player.AILMENT_CODES[Player.PARALYZED] = 'PA';
Player.AILMENT_CODES[Player.ASLEEP] = 'SL';
Player.AILMENT_CODES[Player.POISONED] = 'PO';
Player.AILMENT_CODES[Player.MUTE] = 'MU';
Player.AILMENT_CODES[Player.CLAMPED] = 'CL';


Player.prototype = {
	sustainInjury: function(bodyPart, turns, silent){
		if (!turns){
			turns = Utils.rand(3, 6); 
		}
		this.injuredMap[bodyPart] = {turns: turns};
		if (!silent){
			this.party.controller.ui.showMessage(this.name +'\'s '+Player.BODY_PART_NAMES[bodyPart]+' is injured!');	
		}
	},
	applyAilment: function(ailment, turns){
		if (!turns){
			turns = Utils.rand(3, 6); 
		}
		var currentAilment = this.getAilment(ailment);
		if  (currentAilment){
			currentAilment.turns = turns;
		} else {		
			this.statusAilments.push({
				ailment: ailment,
				turns: turns
			});
		}
		this.party.controller.ui.showMessage(this.name +' '+ Player.AILMENT_EFFECTS[ailment]);
	},
	turnHeal: function(){
		for (bodyPart in this.injuredMap){
			if (this.injuredMap[bodyPart] && --this.injuredMap[bodyPart].turns <= 0){
				this.party.controller.ui.showMessage(this.name +'\'s '+Player.BODY_PART_NAMES[bodyPart]+' is no longer injured.');
				this.injuredMap[bodyPart] = false;
			}
		}
		for (var i = 0; i < this.statusAilments.length; i++){
			if (--this.statusAilments[i].turns <= 0){
				this.party.controller.ui.showMessage(this.name +' '+ Player.AILMENT_RECOVERY[this.statusAilments[i].ailment]);
				this.statusAilments.splice(i,1);
				i--;
			}
		}
	},
	getAilment: function(ailment){
		for (var i = 0; i < this.statusAilments.length; i++){
			if (this.statusAilments[i].ailment === ailment){
				return this.statusAilments[i];
			}
		}
		return false;
	},
	passTurn: function(){
		this.turnHeal();
		if (Utils.chance(20)){
			this.magicPoints.recover(1);
		}
		if (this.getAilment(Player.POISONED)){
			if (Utils.chance(40)){
				this.takeDamage(1);
			}
		}
	},
	evadesTrap: function(){
		var evadeChance = this.job.dex * 2;
		if (this.injuredMap[Player.LEFT_LEG]){
			evadeChance = Math.round(evadeChance / 2);
		}
		if (this.injuredMap[Player.RIGHT_LEG]){
			evadeChance = Math.round(evadeChance / 2);
		}
		return Utils.chance(evadeChance);
	},
	getStatusLine: function(){
		var line = '<b>'+this.name+'</b><br/>HP: '+this.hitPoints.current+'<br/>MP: '+this.magicPoints.current+'<br/>'+this.getAilmentsCode();
		/*for (var i = 0; i < this.statusAilments.length; i++){
			line += ' ' + Player.AILMENT_NAMES[this.statusAilments[i].ailment];
		}
		var injuries = '';
		for (bodyPart in this.injuredMap){
			if (this.injuredMap[bodyPart]){
				injuries += Player.BODY_PART_NAMES[bodyPart]+' ';
			}
		}
		if (injuries !== ''){
			line += ' Injuries: '+injuries;
		}
		if (this.statusAilments.length == 0 && injuries === ''){
			line += ' OK';
		}*/
		return line;
	},
	getAilmentsCode: function(){
		var line = '';
		for (var i = 0; i < this.statusAilments.length; i++){
			line += Player.AILMENT_CODES[this.statusAilments[i].ailment];
		}
		return line;
	},
	takeInjury: function(bodyPart){
		this.sustainInjury(bodyPart, false, true);
		this.takeDamage(1);
	},
	takeDamage: function(damage){
		this.hitPoints.reduce(damage);
		this.party.checkGameOver();
	},
	heal: function(bodyPart, healing){
		this.injuredMap[bodyPart] = false;
		this.hitPoints.recover(healing);
	},
	recoverHP: function(healing){
		if (this.hitPoints.current == 0){
			this.party.controller.ui.showMessage(this.name+' is dead.');
		} else {		
			this.hitPoints.recover(healing);
			this.party.controller.ui.showMessage(this.name +' recovers '+healing+' hit points.');
		}
	},
	cureAilments: function(){
		this.statusAilments = [];
	},
	cureAilment: function(ailment){
		for (var i = 0; i < this.statusAilments.length; i++){
			if (this.statusAilments[i].ailment === ailment){
				this.statusAilments.splice(i,1);
				return;
			}
		}
	},
	revive: function(){
		if (this.hitPoints.current <= 0)
			this.hitPoints.current = 1;
	},
	drinkFromFountain: function(){
		switch (Utils.randSplit([0.3, 0.2, 0.1, 0.2, 0.2])){
			case 0:
				this.party.controller.ui.showMessage('"Ahh-Refreshing!" '+ this.name +' recovers 5 hit points.');
				this.hitPoints.recover(5);
				break;
			case 1:
				this.party.controller.ui.showMessage('"Hmm--Delicious!" '+ this.name +' recovers from all ailments.');
				this.cureAilments();
				break;
			case 2:
				this.party.controller.ui.showMessage('"Bleck--Nasty!" '+ this.name +' is hurt by acid for 3 hit points.');
				this.takeDamage(3);
				break;
			case 3:
				this.party.controller.ui.showMessage('"Argh-Choke-Gasp!" '+ this.name +' is poisoned.');
				this.applyAilment(Player.POISONED);
				break;
			case 4:
				this.party.controller.ui.showMessage('"Hmm--No Effect!"');
				break;
		}
	},
	castSpell: function(spell, params){
		this.party.controller.ui.showMessage(this.name+ ' casts '+spell.name+'.');
		switch (spell.effect){
			case 'removeAilmentFromAll':
				this.party.controller.ui.showMessage('All party members are healed from '+spell.param+'.');
				this.party.cureAilment(spell.param);
				break;
			case 'removeAllAilments':
				this.party.controller.ui.showMessage(params.spellTarget.name+' is cured from all ailments.');
				params.spellTarget.cureAilments();
				break;
			case 'openChest':
				var chest = this.party.getCurrentRoom().getFeature('chest');
				if (chest){
					if (Utils.chance(50)){
						this.party.controller.ui.showMessage('"Click!" a bomb trap is disarmed.');
					} else {
						this.party.controller.ui.showMessage('The chest is unlocked.');
					}
					chest.unlocked = true;
				} else {
					this.party.controller.ui.showMessage('Nothing happens.');
				}
				break;
			case 'heal':
				if (params.spellTarget.hitPoints.current == 0){
					this.party.controller.ui.showMessage(params.spellTarget.name+' is dead.');
				} else {
					this.party.controller.ui.showMessage(params.spellTarget.name+' recovers '+spell.param+' hitpoints.');
					params.spellTarget.heal(params.bodyPart, spell.param);
				}
				break;
			case 'counter':
				var counter = {
					time: spell.param.time,
					message: '',
					offMessage: '',
					isBattleCounter: true
				}
				if (spell.targeted){
					var name = params.spellTarget.name;
					if (!name && params.spellTarget.race)
						name = params.spellTarget.race.name;
					counter.message = name + ' ';
					counter.offMessage = name + ' ';
				}
				counter.message += spell.param.message;
				counter.offMessage += spell.param.offMessage;
				this.party.controller.addCounter(counter);
				break;
			case 'blink':
				this.party.blink(params.direction);
				break;
			case 'removeField':
				var corridor = this.party.getCurrentRoom().corridors[params.direction];
				if (corridor && corridor.obstacle){
					corridor.obstacle = null; // TODO: Only for fields when other type of obstacles implemented
					this.party.controller.ui.showMessage('The field disappears');
				} else {
					this.party.controller.ui.showMessage('Nothing happens');
				}
				break;
			case 'revivePlayer':
				this.party.controller.ui.showMessage(params.spellTarget.name+' is alive');
				if (params.spellTarget.hitPoints.current <= 0)
					params.spellTarget.revive();
				break;
		}
		if (this.party.getCurrentRoom().enemies.length > 0){
			this.party.controller.addCounter({
				time: 20,
				message: this.name+' is recovering power',
				offMessage: this.name+' can cast spells now',
				isBattleCounter: true
			});	
		}
		this.spendMP(spell.cost);
	},
	spendMP: function(points){
		this.magicPoints.reduce(points);
	},
	openChest: function(){
		var chest = this.party.getCurrentRoom().getFeature('chest');
		if (!chest.unlocked && Utils.chance(50)){
			this.party.controller.ui.showMessage('The chest is trapped! BOOM!');
			this.sustainInjury((Utils.chance(50) ? Player.LEFT : Player.RIGHT)+'-'+(Utils.chance(50) ? Player.ARM : Player.LEG));
		}
		this.party.controller.ui.showMessage('The chest contains a '+chest.item.name);
		this.party.addItem(chest.item);
	}
}

module.exports = Player;
},{"./Stat.class":13,"./Utils":15}],9:[function(require,module,exports){
function Room(level, features){
	this.level = null;
	this.enemies = null;
	this.items = null;
	this.features = null;
	this.description = null;
	this.x = null;
	this.y = null;
	this.corridors = {
		north: null,
		south: null,
		west: null,
		east: null
	}
	this.gmTips = null;
	this.init(level, features);
}

Room.prototype = {
	init: function(level, features){
		this.level = level;
		this.description = features.description;
		this.enemies = features.enemies;
		this.items = features.items;
		this.features = features.features;
		this.gmTips = features.gmTips;
	},
	locate: function(x, y){
		this.x = x;
		this.y = y;
	},
	endBattle: function(){
		this.spawnEnemies = false;
		this.enemies = [];
	},
	removeFeature: function(type){
		for (var i = 0; i < this.features.length; i++){
			if  (this.features[i].type === type){
				this.features.splice(i,1);
				i--;
			}
		}
	},
	getFeature: function(type){
		for (var i = 0; i < this.features.length; i++){
			if (this.features[i].type === type){
				return this.features[i];
			}
		}
		return false;
	}
}

module.exports = Room;
},{}],10:[function(require,module,exports){
var Room = require('./Room.class');
var Utils = require('./Utils');

var RoomGenerator = {
	generateRoom: function(scenario, level, specs){
		var features = [];
		if (specs && specs.addStairsUp){
			features.push({type:'upstairs', description: 'Stairway going up'});
		}
		if (specs && specs.addStairsDown){
			features.push({type:'downstairs', description: 'Stairway going down'});
		}
		if (specs && specs.addWinArtifact){
			features.push({type:'winArtifact', description: 'Winning Artifact'});
		}
		if (specs.addFountain){
			features.push({type:'fountain', description: 'A fountain'});
		}
		if (Utils.chance(10)){
			features.push({type:'chest', description: 'A chest', item: Utils.randomElementOf(scenario.items)});
		}

		var enemies = []; // Room can potentially start with a set of enemies
		var room = new Room(level, {	
			description: "A plain room.",
			items: [],
			enemies: enemies,
			features: features,
			gmTips: specs.gmTips
		});	
		room.spawnEnemies = Utils.chance(55);
		if (Utils.chance(5)){
			room.items.push(Utils.randomElementOf(scenario.items));
		}

		if (specs && specs.isEntrance)
			room.isEntrance = true;
		if (specs && specs.isExit)
			room.isExit = true;
		return room;
	}
};

module.exports = RoomGenerator;
},{"./Room.class":9,"./Utils":15}],11:[function(require,module,exports){
var LoadScenario = require('./LoadScenario');

function Scenario(dungeon){
	var scenario = LoadScenario.getScenario(window.exodusConfig.scenario);
	this.jobs = scenario.jobs;
	this.spells = scenario.spells;
	this.items = scenario.items;
	this.enemies = scenario.enemies;
}

Scenario.prototype = {
	setDungeon: function(dungeon){
		dungeon = LoadScenario.getDungeon(dungeon);
		this.endRooms = dungeon.endRooms;
		this.compileEcosystems();
	},
	getJobs: function(){
		return this.jobs;
	},
	getJob: function(code){
		for (var i = 0; i < this.jobs.length; i++){
			if (this.jobs[i].name === code){
				return this.jobs[i];
			}
		}
		return false;
	},
	getSpell: function(name){
		for (var i = 0; i < this.spells.length; i++){
			if (this.spells[i].name === name){
				return this.spells[i];
			}
		}
		return false;
	},
	getPossibleEnemies: function(depth){
		return this.ecosystems[depth];
	},
	compileEcosystems: function(){
		this.ecosystems = {};
		for (var i = 1; i <= 8; i++){
			this.ecosystems[i] = [];
		};
		for (var i = 0; i < this.enemies.length; i++){
			var enemy = this.enemies[i];
			for (var j = enemy.from; j <= enemy.to; j++){
				this.ecosystems[j].push(enemy);
			}
		}
	}
}

module.exports = Scenario;

},{"./LoadScenario":6}],12:[function(require,module,exports){
var Utils = require('./Utils');

function Staff(specs, controller){
	this.controller = controller;
	this.staffPlayers = specs.staffPlayers;
}

Staff.prototype = {
	selectEnemyParty: function(){
		var level = this.controller.party.level;
		var depth = level.depth;
		var ecosystem = this.controller.scenario.getPossibleEnemies(depth);
		var numberOfEnemies = this.controller.party.players.length;
		var ret = [];
		out: for (var i = 0; i < numberOfEnemies; i++){
			var staffPlayer = Utils.randomElementOf(this.staffPlayers);
			for (var j = 0; j < ret.length; j++){
				if (ret[j].staffPlayer == staffPlayer){
					i--;
					continue out;
				}
			}
			ret.push({
				staffPlayer: staffPlayer,
				race: Utils.randomElementOf(ecosystem),
				hitPoints: Math.ceil(depth * 1.5),
				level: depth
			});
		}
		return ret;
	}
};

module.exports = Staff;
},{"./Utils":15}],13:[function(require,module,exports){
function Stat(max){
	this.max = max;
	this.current = max;
}

Stat.prototype = {
	reduce: function(points){
		this.current -= points;
		if (this.current < 0){
			this.current = 0;
		}
	},
	recover: function(points){
		this.current += points;
		if (this.current > this.max){
			this.current = this.max;
		}
	},

}

module.exports = Stat;
},{}],14:[function(require,module,exports){
var DOM = require('./DOM');
var Player = require('./Player.class');
var Corridor = require('./Corridor.class');
var Utils = require('./Utils');

function UI(controller){
	this.controller = controller;
	this._bindEvents(controller);
	this._initCordova();
	this._initTitleScreen();
	this.initComponents();
	this.createNewPlayerRow();
	this.mapCanvas = null;
	this.showMap = false;
	this.counters = [];
	this._disableActionButtons();
};

UI.prototype = {
	_initTitleScreen: function(){
		if (window.exodusConfig.musicCredits)
			DOM.byId('lblMusicCredits').innerHTML = window.exodusConfig.musicCredits;
		DOM.byId('lblBuildInfo').innerHTML = window.exodusConfig.buildTitle + ' v' + window.exodusConfig.version;
		this.exodusConfig = window.exodusConfig;
	},
	initMap: function(){
		this.mapCanvas = DOM.byId('mapCanvas');
		this.mapCanvasCtx = this.mapCanvas.getContext("2d");
		this.mapCanvasCtx.font = '14px sans-serif';
		var sUI = this;
		window.requestAnimationFrame(function(){
			sUI.update();
		});
	},
	updateTargetComboBoxes: function(){
		var selectedAction = DOM.val('cmbAction');
		DOM.selectAll('.commandTargetRow', function(e){e.style.display = 'none'});
		if (selectedAction === 'castSpell'){
			DOM.byId('cmbSpellsRow').style.display = 'table-row';
			DOM.byId('cmbPlayerRow').style.display = 'table-row';
			spell = this.controller.scenario.getSpell(DOM.val('cmbSpell'));
			switch (spell.targetType){
				case 'friend':
					DOM.byId('cmbSpellTargetRow').style.display = 'table-row';
					break;
				case 'enemy':
					DOM.byId('cmbTargetEnemyRow').style.display = 'table-row';
					break;
				case 'direction':
					DOM.byId('cmbDirectionsRow').style.display = 'table-row';
					break;
				case 'friendLimb':
					DOM.byId('cmbSpellTargetRow').style.display = 'table-row';
					DOM.byId('cmbBodyPartRow').style.display = 'table-row';
					break;
			}
		} else if (selectedAction === 'useEnemySkill'){
			DOM.byId('cmbTargetEnemyRow').style.display = 'table-row';
		} else if (selectedAction === 'takeItem'){
			DOM.byId('cmbItemOnFloorRow').style.display = 'table-row';
		} else if (selectedAction === 'useItem') {
			DOM.byId('cmbPlayerRow').style.display = 'table-row';
			DOM.byId('cmbItemRow').style.display = 'table-row';
		} else if (selectedAction === 'openChest' || selectedAction === 'drink') {
			DOM.byId('cmbPlayerRow').style.display = 'table-row';
		}
	},
	initComponents: function(){
		var thus = this;
		var actionTable = DOM.byId('actionsTable')
		// Action
		var tr = DOM.create('tr');
		tr.id = 'commandActionRow';
		actionTable.appendChild(tr);
		var td = DOM.create('td');
		tr.appendChild(td);
		td.innerHTML = 'Action';
		var td = DOM.create('td');
		tr.appendChild(td);
		var element = DOM.create('select');
		element.id = 'cmbAction';
		td.appendChild(element);
		element.onchange = function(){
			thus.updateTargetComboBoxes();
		}

		// Spells
		var tr = DOM.create('tr');
		actionTable.appendChild(tr);
		var td = DOM.create('td');
		tr.appendChild(td);
		tr.className = 'commandTargetRow';
		tr.id = 'cmbSpellsRow';
		td.innerHTML = 'Spell';
		var td = DOM.create('td');
		tr.appendChild(td);
		var element = DOM.create('select');
		element.id = 'cmbSpell';
		td.appendChild(element);
		var spells = this.controller.scenario.spells;
		spells.sort(function(a,b){
			if (a.name > b.name)
				return 1;
			else
				return -1;
		});
		for (var i = 0; i < spells.length; i++){
			var option = DOM.create('option');
			option.value = spells[i].name;
			if (spells[i].effect === 'physical')
				option.innerHTML = '* '+spells[i].name + '['+spells[i].cost+']';
			else
				option.innerHTML = spells[i].name + '['+spells[i].cost+']';
			element.appendChild(option);
		}
		element.onchange = function(){
			thus.updateTargetComboBoxes();
		}

		// Player
		var tr = DOM.create('tr');
		tr.className = 'commandTargetRow';
		tr.id = 'cmbPlayerRow';
		actionTable.appendChild(tr);
		var td = DOM.create('td');
		tr.appendChild(td);
		td.innerHTML = 'Player';
		var td = DOM.create('td');
		tr.appendChild(td);
		var element = DOM.create('select');
		element.id = 'cmbPlayer';
		td.appendChild(element);

		// Spell Target
		var tr = DOM.create('tr');
		tr.className = 'commandTargetRow';
		tr.id = 'cmbSpellTargetRow';
		actionTable.appendChild(tr);
		var td = DOM.create('td');
		tr.appendChild(td);
		td.innerHTML = 'Spell Target';
		var td = DOM.create('td');
		tr.appendChild(td);
		var element = DOM.create('select');
		element.id = 'cmbSpellTarget';
		td.appendChild(element);

		// Enemy Spell Target
		var tr = DOM.create('tr');
		tr.className = 'commandTargetRow';
		tr.id = 'cmbTargetEnemyRow';
		actionTable.appendChild(tr);
		var td = DOM.create('td');
		tr.appendChild(td);
		td.innerHTML = 'Spell Target (Enemy)';
		var td = DOM.create('td');
		tr.appendChild(td);
		var element = DOM.create('select');
		element.id = 'cmbSpellTargetEnemy';
		td.appendChild(element);

		// Item on Floor Target
		var tr = DOM.create('tr');
		tr.className = 'commandTargetRow';
		tr.id = 'cmbItemOnFloorRow';
		actionTable.appendChild(tr);
		var td = DOM.create('td');
		tr.appendChild(td);
		td.innerHTML = 'Item';
		var td = DOM.create('td');
		tr.appendChild(td);
		var element = DOM.create('select');
		element.id = 'cmbItemOnFloor';
		td.appendChild(element);

		// Item Target
		var tr = DOM.create('tr');
		tr.className = 'commandTargetRow';
		tr.id = 'cmbItemRow';
		actionTable.appendChild(tr);
		var td = DOM.create('td');
		tr.appendChild(td);
		td.innerHTML = 'Item';
		var td = DOM.create('td');
		tr.appendChild(td);
		var element = DOM.create('select');
		element.id = 'cmbItem';
		td.appendChild(element);		

		// Body part
		var tr = DOM.create('tr');
		tr.className = 'commandTargetRow';
		tr.id = 'cmbBodyPartRow';
		actionTable.appendChild(tr);
		var td = DOM.create('td');
		tr.appendChild(td);
		td.innerHTML = 'Body Part';
		var td = DOM.create('td');
		tr.appendChild(td);
		var bodyPartSelect = this._createBodyPartSelect();
		bodyPartSelect.id = 'cmbBodyPart';
		td.appendChild(bodyPartSelect);


		// Directions
		var tr = DOM.create('tr');
		tr.className = 'commandTargetRow';
		tr.id = 'cmbDirectionsRow';
		actionTable.appendChild(tr);
		var td = DOM.create('td');
		tr.appendChild(td);
		td.innerHTML = 'Direction';
		var td = DOM.create('td');
		tr.appendChild(td);
		var element = DOM.create('select');
		element.id = 'cmbDirection';
		td.appendChild(element);
		var option = DOM.create('option');
		option.value = 'north';
		option.innerHTML = 'North';
		element.appendChild(option);
		var option = DOM.create('option');
		option.value = 'south';
		option.innerHTML = 'South';
		element.appendChild(option);
		var option = DOM.create('option');
		option.value = 'west';
		option.innerHTML = 'West';
		element.appendChild(option);
		var option = DOM.create('option');
		option.value = 'east';
		option.innerHTML = 'East';
		element.appendChild(option);

		// Action Button
		var tr = DOM.create('tr');
		actionTable.appendChild(tr);
		var td = DOM.create('td');
		td.colSpan = 2;
		tr.appendChild(td);
		var button = DOM.create('button');
		button.innerHTML = 'Execute';
		button.className = 'actionButton';
		button.id = 'btnExecute';
		var thus = this;
		button.onclick = function(){
			thus.executeAction();
		}
		td.appendChild(button);
		this.updateTargetComboBoxes();

		// Dungeons
		var cmbDungeon = DOM.byId('cmbDungeon');
		var dungeons = this.exodusConfig.dungeons;
		for (var i = 0; i < dungeons.length; i++){
			option = DOM.create('option');
			option.value = dungeons[i].module;
			option.innerHTML = dungeons[i].name;
			cmbDungeon.appendChild(option);
		}
	},
	toogleTimeFreeze: function(){
		this.timeFrozen = !this.timeFrozen;
		DOM.byId('btnFreezeTime').innerHTML = this.timeFrozen ? 'Resume Game': 'Spell! (Freeze Time)';
		this.updateRoomData();
	},
	executeAction: function(){
		var command = {
			action: DOM.val('cmbAction'),
			spell: DOM.val('cmbSpell'),
			player: DOM.val('cmbPlayer'),
			spellTarget: DOM.val('cmbSpellTarget'),
			spellTargetEnemy: DOM.val('cmbSpellTargetEnemy'),
			itemOnFloor: DOM.val('cmbItemOnFloor'),
			item: DOM.val('cmbItem'),
			bodyPart: DOM.val('cmbBodyPart'),
			direction: DOM.val('cmbDirection')
		};
		var action = this.currentAvailableActions[command.action];
		if (this.controller.inputStatus === this.controller.COMBAT && !action.onBattle){
			this.showMessage('Cannot do this while on combat!!');
			return;
		}
		if (command.action === 'toogleMap'){
			this.showMap = !this.showMap;
			return;
		}
		if (command.action === 'stopMusic'){
			this.stopMusic();
			return;
		}
		if (command.action === 'castSpell'){
			var spell = this.controller.scenario.getSpell(command.spell);
			var player = this.controller.party.getPlayerByNumber(command.player);
			if (player.magicPoints.current < spell.cost){
				alert('Not enough MP');
				return;
			}
			if (spell.physicalHitCheck){
				//The spell may fail, requires checking physical hit
				if (!confirm('Did the spell hit the target?')){
					this.controller.spellFailed(command);
					return;
				}
			}
		}
		this.controller.execute(command);
		
	},
	_bindEvents: function(controller){
		DOM.onClick('btnMoveNorth', function() { move(0, -1); });
		DOM.onClick('btnMoveSouth', function() { move(0, 1); });
		DOM.onClick('btnMoveWest', function() { move(-1, 0); });
		DOM.onClick('btnMoveEast', function() { move(1, 0); });
		DOM.onClick('btnStartGame', controller.startGame, controller);
		DOM.onClick('btnAddPlayer', this.createNewPlayerRow, this);
		DOM.onClick('btnAddStaffPlayer', this.createNewStaffPlayerRow, this);
		DOM.onClick('btnSelectTargets', this._targetsSelected, this);
		DOM.onClick('btnEndCombat', this._battleOver, this);
		DOM.onClick('btnFreezeTime', this.toogleTimeFreeze, this);
		DOM.onClick('btnNewGame', this._hideTitle, this);
	},
	update: function(){
		// Fill background
		this.mapCanvasCtx.fillStyle = "#FFFFFF";
		this.mapCanvasCtx.fillRect(0, 0, 340, 355);
		if (this.showMap){
			this._drawMap();
		} else {
			this._drawRoom();
		}
		this._drawPartyStatus();
		var sUI = this;
		window.requestAnimationFrame(function(){
			sUI.update();
		});
	},
	_drawPartyStatus: function(){
		var party = this.controller.party;
		for (var i = 0; i < party.players.length; i++){
			var player = party.players[i];
			this._drawPlayerIcon(i * 80 + 20, 270, player);
		}
	},
	_drawPlayerIcon: function(x, y, player){
		var ctx = this.mapCanvasCtx;
		var size = 20;
		ctx.fillStyle = '#000000';
		ctx.fillRect(x+size, y, size, size*3);
		ctx.fillStyle = this._getBodyPartColor(player, Player.LEFT_LEG);
		ctx.fillRect(x, y+size*3, size, size);
		ctx.fillStyle = this._getBodyPartColor(player, Player.RIGHT_LEG);
		ctx.fillRect(x+size*2, y+size*3, size, size);
		ctx.fillStyle = this._getBodyPartColor(player, Player.LEFT_ARM);
		ctx.fillRect(x, y+size, size, size);
		ctx.fillStyle = this._getBodyPartColor(player, Player.RIGHT_ARM);
		ctx.fillRect(x+size*2, y+size, size, size);
	},
	_getBodyPartColor: function (player, bodyPart){
		if (player.injuredMap[bodyPart]){
			return '#FF0000';
		} else {
			return '#000000';
		}
	},
	_drawMap: function(){
		var ctx = this.mapCanvasCtx;
		var party = this.controller.party;
		var level = party.level;
		var blockSize = 20;
		var size = blockSize * 3;
		var scale = 40;
		var lineWidth = 2;
		for (var i = 0; i < level.rooms.length; i++){
			var room = level.rooms[i];
			// Base white room
			ctx.fillStyle = "#FFFFFF";
			ctx.fillRect(room.x * scale, room.y * scale, size, size);
			// Fill the 4 fixed blocks with blackness
			ctx.fillStyle = "#000000";
			ctx.fillRect(room.x * scale, room.y * scale, blockSize, blockSize);
			ctx.fillRect(room.x * scale, room.y * scale + 2 * blockSize, blockSize, blockSize);
			ctx.fillRect(room.x * scale + 2 * blockSize, room.y * scale, blockSize, blockSize);
			ctx.fillRect(room.x * scale + 2 * blockSize, room.y * scale + 2 * blockSize, blockSize, blockSize);
			// Now, fill the corridors
			ctx.fillStyle = this._getCorridorColor(room.corridors.north);
			ctx.fillRect(room.x * scale + blockSize, room.y * scale, blockSize, blockSize);
			ctx.fillStyle = this._getCorridorColor(room.corridors.south);
			ctx.fillRect(room.x * scale + blockSize, room.y * scale + 2 * blockSize, blockSize, blockSize);
			ctx.fillStyle = this._getCorridorColor(room.corridors.west);
			ctx.fillRect(room.x * scale, room.y * scale + blockSize, blockSize, blockSize);
			ctx.fillStyle = this._getCorridorColor(room.corridors.east);
			ctx.fillRect(room.x * scale + 2 * blockSize, room.y * scale + blockSize, blockSize, blockSize);
			// Show enemies
			if (room.spawnEnemies || room.enemies.length > 0){
				ctx.lineWidth= lineWidth;
				ctx.strokeStyle="#ff00d5";
				ctx.strokeRect(room.x * scale + blockSize + lineWidth / 2, room.y * scale + blockSize + lineWidth / 2, blockSize - lineWidth, blockSize - lineWidth );
			}
			// Add stairs down and up
			if (room.isExit){
				ctx.fillStyle = "#0000FF";
				ctx.fillRect(room.x * scale + blockSize, room.y * scale + blockSize, blockSize, blockSize);
			}
			/*if (room.isEntrance){
				ctx.fillStyle = "#0000FF";
				ctx.fillRect(room.x * scale + blockSize, room.y * scale + blockSize, blockSize, blockSize);
			}*/
			// Show party location
			if (party.location.x == room.x && party.location.y == room.y){
				ctx.fillStyle = "#888888";
				ctx.fillRect(room.x * scale + blockSize, room.y * scale + blockSize, blockSize, blockSize);
			}
		}
	},
	_drawRoom: function(){
		var ctx = this.mapCanvasCtx;
		var party = this.controller.party;
		var room = party.getCurrentRoom();
		var level = party.level;
		var blockSize = 20;
		var x = 100;
		var y = 20;
		// Fill the room border with blackness
		ctx.fillStyle = "#000000";
		ctx.fillRect(x, y, blockSize * 7, blockSize * 7);
		ctx.fillStyle = "#FFFFFF";
		ctx.fillRect(x+blockSize, y+blockSize, blockSize * 5, blockSize * 5);

		// Now, fill the corridors
		if (room.corridors.north){
			ctx.fillStyle = this._getCorridorColor(room.corridors.north);
			ctx.fillRect(x+3 * blockSize, y, blockSize, blockSize);
		}
		if (room.corridors.south){
			ctx.fillStyle = this._getCorridorColor(room.corridors.south);
			ctx.fillRect(x+3 * blockSize, y+6 * blockSize, blockSize, blockSize);
		}
		if (room.corridors.west){
			ctx.fillStyle = this._getCorridorColor(room.corridors.west);
			ctx.fillRect(x, y + 3 * blockSize, blockSize, blockSize);
		}
		if (room.corridors.east){
			ctx.fillStyle = this._getCorridorColor(room.corridors.east);
			ctx.fillRect(x + 6 * blockSize, y + 3 * blockSize, blockSize, blockSize);
		}
	},
	_getCorridorColor: function(corridor){
		if (!corridor)
			return '#000000';
		if (corridor.obstacle){
			switch (corridor.obstacle.type){
				case Corridor.FIRE_FIELD:
					return '#FF0000';
				case Corridor.POISON_FIELD:
					return '#00FF00';
				case Corridor.SLEEP_FIELD:
					return '#FF00FF';
			}
		}
		return "#FFFFFF";
	},
	_hideTitle: function(){
		DOM.byId('titleSection').style.display = 'none';
		DOM.byId('newGame').style.display = 'block';
	},
	hideNewGamePanel: function(){
		var ui = this;
		DOM.byId('newGame').style.display = 'none';
		DOM.byId('movementButtons').style.display = 'block';
		this.setMovementButtons();
		var partyMembers = DOM.byId('partyMembersSection');
		var bodypartHitSelection = DOM.byId('bodypartHitSelection');
		var bodypartTitle = DOM.create('p');
		bodypartTitle.className = 'gmTip';
		bodypartTitle.innerHTML = 'When all enemies are down, register all the hits sustained by the party';
		bodypartHitSelection.appendChild(bodypartTitle);
		for (var i = 0; i < this.controller.party.players.length; i++){
			var player = this.controller.party.players[i];
			// Add a row for the target selection section with a checkbox
			var playerRow = DOM.create('div');
			var selectPlayerCheckbox = DOM.create('input');
			selectPlayerCheckbox.type = 'checkbox';
			selectPlayerCheckbox.className = 'selectPlayerCheckbox';
			selectPlayerCheckbox.playerId = player.number;
			playerRow.appendChild(selectPlayerCheckbox);
			var playerInfoDiv = DOM.create('span');
			playerInfoDiv.innerHTML = player.name;
			playerRow.appendChild(playerInfoDiv);
			partyMembers.appendChild(playerRow);

			// Add a row to the bodypart hit section
			playerRow = DOM.create('div');
			var playerNameSpan = DOM.create('span');
			playerNameSpan.innerHTML = player.name;
			playerRow.appendChild(playerNameSpan);
			playerRow.appendChild(DOM.create('br'));

			var bodyPartSelect = this._createBodyPartSelect();
			bodyPartSelect.id = 'bodyPartSelect'+player.number;
			bodyPartSelect.className = 'combatComponent';
			bodyPartSelect.classList.add('actionButton');
			playerRow.appendChild(bodyPartSelect);

			var takeDamageButton = DOM.create('button');
			takeDamageButton.innerHTML = 'Hit '+player.name+'!';
			takeDamageButton.className = 'combatComponent';
			takeDamageButton.classList.add('actionButton');
			(function(player){
				DOM.onClick(takeDamageButton, function() {
					var bodyPart = DOM.val('bodyPartSelect'+player.number);
					player.takeInjury(bodyPart);
					ui.updateRoomData();
				});
			})(player);
			playerRow.appendChild(takeDamageButton);
			bodypartHitSelection.appendChild(playerRow);

			// Add player status div
			var playerStatusDiv = DOM.create('div');
			DOM.byId('playersStatusSection').appendChild(playerStatusDiv);
			playerStatusDiv.id = 'playerStatusDiv_'+i;
			playerStatusDiv.className = 'playerStatusDiv';

			// Fill player comboboxes
			cmbPlayer = DOM.byId('cmbPlayer');
			playerOption = DOM.create('option');
			playerOption.value = player.number;
			playerOption.innerHTML = player.name;
			cmbPlayer.appendChild(playerOption)

			var cmbSpellPlayer = DOM.byId('cmbSpellTarget');
			playerOption = DOM.create('option');
			playerOption.value = player.number;
			playerOption.innerHTML = player.name;
			cmbSpellPlayer.appendChild(playerOption)
		}
		DOM.selectAll('.selectPlayerCheckbox', function(e){e.style.display = 'none'});
		DOM.byId('inGame').style.display = 'block';
		this.playMusic('explore');
	},
	_createBodyPartSelect: function(){
		var select = DOM.create('select');
		select.className = 'playerBodyPartSelect';
		var options = [
			{value: Player.TORSO, label: 'Torso'},
			{value: Player.LEFT_ARM, label: 'Left Arm'},
			{value: Player.RIGHT_ARM, label: 'Right Arm'},
			{value: Player.LEFT_LEG, label: 'Left Leg'},
			{value: Player.RIGHT_LEG, label: 'Right Leg'},
		];
		for (var i = 0; i < options.length; i++){
			var option = DOM.create('option');
			option.value =  options[i].value;
			option.innerHTML = options[i].label;
			select.appendChild(option);	
		}
		return select;
	},
	getNewGameConfig: function(){
		var dungeonW = parseInt(DOM.val('txtDungeonW'));
		var dungeonH = parseInt(DOM.val('txtDungeonH'));
		var startingLevel = 1;
		var roomDensity = DOM.val('cmbRoomDensity');
		var dungeon = DOM.val('cmbDungeon');

		var players = [];
		var names = DOM.selectAll('.playerNameText');
		var classes = DOM.selectAll('.playerClassCombo');
		for (var i = 0; i < names.length; i++){
			players.push({
				name: names[i].value,
				job: classes[i].value
			});
		}

		var staffPlayers = [];
		var staffNames = DOM.selectAll('.staffPlayerNameText');
		for (var i = 0; i < staffNames.length; i++){
			staffPlayers.push({
				name: staffNames[i].value
			});
		}


		return {
			dungeon: dungeon,
			dungeonSize: {
				w: dungeonW,
				h: dungeonH
			},
			startingLevel: startingLevel,
			roomDensity: roomDensity,
			players: players,
			staffPlayers: staffPlayers
		}
	},
	updateRoomData: function(){
		var party = this.controller.party;
		var room = this.controller.party.getCurrentRoom();
		var html = '<p>You are in level '+party.level.depth+' of the dungeon</p>';
		for (var i = 0; i < this.controller.party.players.length; i++){
			DOM.byId('playerStatusDiv_'+i).innerHTML = this.controller.party.players[i].getStatusLine();
		}
		var inBattle = room.enemies.length > 0;
		if (inBattle){
			html += '<h3>Monsters!</h3><p>'+this._buildList(room.enemies, 
				function(element){
					var html = element.race.name +' ('+element.staffPlayer.name+')' + ' HP: '+element.hitPoints;
					if (element.race.sp)
						html += ' SP: '+element.race.sp;
					if (element.race.intrinsics){
						html += '<br>Intrinsics: '+element.race.intrinsics;
					}
					if (element.race.skills){
						html += '<br>Skills:<br>';
						for (var i = 0; i < element.race.skills.length; i++){
							var skill = element.race.skills[i];
							html += skill.name+': '+skill.description+'<br>';
						}
					}

					return html;
				}
			)+'</p>';
			// Monster target for spells
			var cmbSpellPlayer = DOM.byId('cmbSpellTargetEnemy');
			cmbSpellPlayer.innerHTML = '';
			for (var i = 0; i < room.enemies.length; i++){
				var enemy = room.enemies[i];
				playerOption = DOM.create('option');
				playerOption.value = i;
				playerOption.innerHTML = enemy.race.name + ' ('+enemy.staffPlayer.name+')';
				cmbSpellPlayer.appendChild(playerOption)
			}
		}
		if (room.items.length > 0){
			html += '<h3>Items</h3><p>'+this._buildList(room.items, 
				function(element){
					return element.name;
				}
			)+'</p>';
		}
		var cmbItem = DOM.byId('cmbItemOnFloor');
		cmbItem.innerHTML = '';
		for (var i = 0; i < room.items.length; i++){
			var item = room.items[i];
			playerOption = DOM.create('option');
			playerOption.value = i;
			playerOption.innerHTML = item.name;
			cmbItem.appendChild(playerOption)
		}
			
		if (party.items.length > 0){
			html += '<h3>Inventory</h3><p>'+this._buildList(party.items, 
				function(element){
					return element.name;
				}
			)+'</p>';
		}	
		var cmbItem = DOM.byId('cmbItem');
		cmbItem.innerHTML = '';
		for (var i = 0; i < party.items.length; i++){
			var item = party.items[i];
			playerOption = DOM.create('option');
			playerOption.value = i;
			playerOption.innerHTML = item.name;
			cmbItem.appendChild(playerOption)
		}
		
		if (room.features.length > 0) {
			html += '<h3>Features</h3><p>'+this._buildList(room.features, 
 				function(element){
 					return element.description;
 				}
 			)+'</p>';
		}

		if (room.gmTips){
			html += '<p><b>'+room.gmTips.name+'</b></p>';
			html += '<p class = "gmTip">'+room.gmTips.helpText+'</p>';
		}

		DOM.byId('roomDescription').innerHTML = html;

		var actions = [];
		if (!inBattle)
			actions.push({code: 'passTurn', name: 'Stand', onBattle: false});
		if (!inBattle || this.timeFrozen)
			actions.push({code: 'castSpell', name: 'Cast Spell', onBattle: true});
		if (inBattle && this.timeFrozen)
			actions.push({code: 'useEnemySkill', name: 'Use Enemy Skill', onBattle: true});
		actions.push({code: 'toogleMap', name: 'Toogle Map', onBattle: true});
		if (party.items.length > 0 && (!inBattle || this.timeFrozen)){
			actions.push({code: 'useItem', name: 'Use Item', onBattle: true});
		}
		if (!inBattle) for (var i = 0; i < room.features.length; i++){
			var feature = room.features[i];
			switch (feature.type){
				case 'upstairs':
					actions.push({code: 'upstairs', name: 'Go Up', onBattle: false});
					break;
				case 'downstairs':
					actions.push({code: 'downstairs', name: 'Go Down', onBattle: false});
					break;
				case 'winArtifact':
					actions.push({code: 'win', name: 'Win Game', onBattle: false});
					break;
				case 'fountain':
					actions.push({code: 'drink', name: 'Drink', onBattle: false});
					break;
				case 'chest':
					actions.push({code: 'openChest', name: 'Open Chest', onBattle: false});
					break;
			}
		}
		if (!inBattle) if (room.items.length > 0){
			actions.push({code: 'takeItem', name: 'Pick up item', onBattle: false});
		}
		if (inBattle){
			var canSleep = false;
			var canNegate = false;
			for (var i = 0; i < room.enemies.length; i++){
				var enemy = room.enemies[i];
				if (enemy.race.skills) for (var j = 0; j < enemy.race.skills.length; j++){
					var skill = enemy.race.skills[j];
					if (skill.special && skill.special === 'negate'){
						canNegate = true;
					}
					if (skill.special && skill.special === 'sleep'){
						canSleep = true;	
					}
				}
			}
			if (canSleep){
				actions.push({code: 'enemySleepAll', name: '* Enemy Sleep All', onBattle: true});
			}
			if (canNegate){
				actions.push({code: 'enemyNegateTime', name: '* Enemy Negate Time', onBattle: true});
			}
		}
		actions.push({code: 'stopMusic', name: '* Stop Music', onBattle: true});
		var roomActionsCmb = DOM.byId('cmbAction');
		roomActionsCmb.innerHTML = ''; // Can be done better but me lazy
		this.currentAvailableActions = {};
		for (var i = 0; i < actions.length; i++){
			var actionChild = DOM.create('option');
			actionChild.value = actions[i].code;
			actionChild.innerHTML = actions[i].name;
			this.currentAvailableActions[actions[i].code] = actions[i];
			roomActionsCmb.appendChild(actionChild);
		}
		
		this.updateTargetComboBoxes();
		this.setMovementButtons();
	},
	_buildList: function(arr, renderer){
		var html = '<ul>';
		for (var i = 0; i < arr.length; i++){
			html += '<li>'+renderer(arr[i])+'</li>';
		}

		html += '</ul>';
		return html;
	},
	createNewPlayerRow: function(){
		var table = DOM.byId('tblPlayersInfo');
		var tr = DOM.create('tr');
		var td = DOM.create('td');
		var component = DOM.create('input');
		component.type = 'text';
		component.className = 'playerNameText';
		td.appendChild(component);
		tr.appendChild(td);

		td = DOM.create('td');
		td.innerHTML = 'Adventurers';
		tr.appendChild(td);

		td = DOM.create('td');
		component = DOM.create('select');
		component.className = 'playerClassCombo';
		for (var i = 0; i < this.controller.scenario.jobs.length; i++){
			var job = this.controller.scenario.jobs[i];
			child = DOM.create('option');
			child.value = job.code ? job.code : job.name;
			child.innerHTML = job.name + ' HP: '+job.str+' MP: '+job.magic;
			component.appendChild(child);	
		}
		td.appendChild(component);
		tr.appendChild(td);

		td = DOM.create('td');
		component = DOM.create('button');
		component.innerHTML = 'X';
		component.onclick = function(){
			var players = DOM.selectAll('.playerNameText').length + DOM.selectAll('.staffPlayerNameText').length;
			if (players > 1){
				table.removeChild(tr);
			}
		}
		td.appendChild(component);
		tr.appendChild(td);

		table.appendChild(tr);
	},
	createNewStaffPlayerRow: function(){
		var table = DOM.byId('tblPlayersInfo');
		var tr = DOM.create('tr');
		var td = DOM.create('td');
		var component = DOM.create('input');
		component.type = 'text';
		component.className = 'staffPlayerNameText';
		td.appendChild(component);
		tr.appendChild(td);

		td = DOM.create('td');
		td.innerHTML = 'Dwellers';
		tr.appendChild(td);

		td = DOM.create('td');
		td.innerHTML = 'Monster';
		tr.appendChild(td);

		td = DOM.create('td');
		component = DOM.create('button');
		component.innerHTML = 'X';
		component.onclick = function(){
			var players = DOM.selectAll('.playerNameText').length + DOM.selectAll('.staffPlayerNameText').length;
			if (players > 1){
				table.removeChild(tr);
			}
		}
		td.appendChild(component);
		tr.appendChild(td);

		table.appendChild(tr);
	},
	showMessage: function(message){
		var component = DOM.create('p');
		component.innerHTML = message;
		DOM.byId('messageArea').appendChild(component);
		alert(message);
	},
	clearMessages: function(){
		DOM.byId('messageArea').innerHTML = '';
	},
	_disableActionButtons: function(){

		DOM.selectAll('.actionButton', function(e){
			e.style.display = 'none';
		});
		DOM.selectAll('.commandTargetRow', function(e){
			e.style.display = 'none';
		});
		DOM.byId('commandActionRow').style.display = 'none';

	},
	enableMovement: function(){
		this._disableActionButtons();
		this.setMovementButtons();
		this.updateTargetComboBoxes();
		DOM.byId('commandActionRow').style.display = 'table-row';
		DOM.byId('btnExecute').style.display = 'inline';
	},
	selectTargets: function(cb){
		this._disableActionButtons();
		DOM.byId('playersActionSelection').style.display = 'block';
		this._disableMovemenButtons();

		DOM.selectAll('.selectPlayerCheckbox', function(e){
			e.checked = false;
			e.style.display = 'inline';
		});
		
		this.targetSelectedCb = cb;

	},
	_targetsSelected: function(){
		var targets = [];
		var party = this.controller.party;
		DOM.selectAll('.selectPlayerCheckbox', function(e){
			e.style.display = 'none';
			if (e.checked)
				targets.push(party.getPlayerByNumber(e.playerId));
		});
		this.targetSelectedCb(targets);
		DOM.byId('playersActionSelection').style.display = 'none';
		this.updateRoomData();
	},
	activateCombat: function(){
		DOM.selectAll('.movementButton', function(e){
			e.style.display = 'none';
		});
		this.updateTargetComboBoxes();
		DOM.selectAll('.combatComponent', function(e){
			e.style.display = 'inline';
		});
		DOM.byId('bodypartHitSelection').style.display = 'block';
		this.updateRoomData();
	},
	_battleOver: function(){
		this.controller.endBattle();
		this.controller.setInputStatus(this.controller.MOVE);
		this.updateRoomData();
		DOM.byId('bodypartHitSelection').style.display = 'none';
		if (this.timeFrozen){
			this.toogleTimeFreeze();
		}
		this.playMusic('victory', 'explore');
	},
	_passTurn: function(){
		this.clearMessages();
		this.showMessage('** Waiting **');
		this.controller.passTurn();
		this.updateRoomData();
	},
	addCounter: function(counter){
		var div = DOM.create('div');
		div.id = 'counterDiv'+counter.id;
		div.innerHTML = this._formatSeconds(counter.time)+', '+counter.message;
		this.counters.push(counter);
		DOM.byId('countersSection').appendChild(div);
	},
	updateCounter: function(counter){
		if (counter.killed)
			return;
		var message = counter.message;
		if (counter.time <= 0){
			message = counter.offMessage;
			this.showMessage(message);
		}
		DOM.byId('counterDiv'+counter.id).innerHTML = this._formatSeconds(counter.time)+', '+message;
	},
	removeCounter: function(counter){
		if (counter.killed)
			return;
		DOM.byId('countersSection').removeChild(DOM.byId('counterDiv'+counter.id));
		counter.killed = true;
		for (var i = 0; i < this.counters.length; i++){
			var xcounter = this.counters[i];
			if (xcounter == counter){
				this.counters.splice(i,1);
				break;
			}
		}
	},
	removeAllBattleCounters: function(){
		for (var i = 0; i < this.counters.length; i++){
			var counter = this.counters[i];
			if (counter.isBattleCounter){
				this.removeCounter(counter);
				i--;
			}
		}
	},
	_formatSeconds: function(seconds){
		var minutes = Math.floor(seconds/60);
		var seconds = seconds % 60;
		seconds = seconds < 10 ? '0'+seconds : seconds;
		return minutes +':'+seconds;
	},
	playMusic: function(theme, then, keep){
		var looped = false;
		var track = '';
		if (keep){
			track = this.selectedTrack;
		} else {
			if (typeof this.exodusConfig.music[theme] === 'string'){
				track = this.exodusConfig.music[theme];
			} else {
				track = Utils.randomElementOf(this.exodusConfig.music[theme]);
			}
			this.selectedTrack = track;
		}
		if (theme === 'combat' || theme === 'explore'){
			looped = true;
		}
		track = 'mp3/'+track;
		if (this.currentAudio == null){
			this.currentAudio = new Audio(track);
		} else {
			this.currentAudio.pause();
			this.currentAudio.src = track;
		}
		this.currentAudio.play();
		var thus = this;
		if (looped){
			this.currentAudio.onended=function(){thus.playMusic(theme, false, true);}
		} else {
			this.currentAudio.onended=function(){
				delete thus.currentAudio;
				if (thus.thenPlay){
					thus.playMusic(thus.thenPlay);
				}
			}
		}
		if (then){
			this.thenPlay = then;
		} else {
			this.thenPlay = false;
		}
	},
	stopMusic: function(){
		if (this.currentAudio){
			this.currentAudio.pause();
		}
	},
	setMovementButtons: function(){
		var room = this.controller.party.getCurrentRoom();
		DOM.selectAll('.movementButton', function(e){
			e.style.display = 'none';
		});
		if (room.enemies.length > 0){
			return;
		}
		if (room.corridors.north){
			DOM.byId('btnMoveNorth').style.display = 'inline';
			DOM.byId('btnMoveNorth').innerHTML = 'North: '+room.corridors.north.getDescription();
		}
		if (room.corridors.south){
			DOM.byId('btnMoveSouth').style.display = 'inline';
			DOM.byId('btnMoveSouth').innerHTML = 'South: '+room.corridors.south.getDescription();
		}
		if (room.corridors.west){
			DOM.byId('btnMoveWest').style.display = 'inline';
			DOM.byId('btnMoveWest').innerHTML = 'West: '+room.corridors.west.getDescription();
		}
		if (room.corridors.east){
			DOM.byId('btnMoveEast').style.display = 'inline';
			DOM.byId('btnMoveEast').innerHTML = 'East: '+room.corridors.east.getDescription();
		}
	},
	_disableMovemenButtons: function(){
		DOM.selectAll('.movementButton', function(e){
			e.style.display = 'none';
		});
	},
	setSelectTargetsMessage: function(message){
		DOM.byId('lblSelectTargetsMessage').innerHTML = message;
	},
	_initCordova: function(){
		function onDeviceReady(){
			function onBackKeyDown() {
				if (confirm("Exit EXODUS? Your game will be lost")){
					navigator.app.exitApp()
				} else {
					return false;
				}
			}
			document.addEventListener("backbutton", onBackKeyDown, false);
		}
		document.addEventListener("deviceready", onDeviceReady, false);
	}
};

module.exports = UI;
},{"./Corridor.class":1,"./DOM":3,"./Player.class":8,"./Utils":15}],15:[function(require,module,exports){
var Utils = {
	rand: function(low, hi){
		return Math.floor(Math.random() * (hi - low + 1))+low;
	},
	randomElementOf: function(array){
    	return array[Math.floor(Math.random()*array.length)];
	},
	randSplit: function(distrib){
		var pivot = Math.random();
		var sum = 0;
		for (var i = 0; i < distrib.length; i++){
			sum += distrib[i];
			if (pivot <= sum){
				return i;
			}
		}
		return 0;
	},
	chance: function(probability){
		return this.rand(0, 100) <= probability;
	},
	pullRandomElementOf: function(array){
		var index = Math.floor(Math.random()*array.length);
		var value = array[index];
		array.splice(index, 1);
    	return value;
	},
	getDirection: function(from, to){
		if (from.x == to.x){
			if (from.y > to.y){
				return 'north';
			} else {
				return 'south';
			}
		} else {
			if (from.x > to.x){
				return 'west';
			} else {
				return 'east';
			}
		}
	},
	DIRECTION_VECTORS: {
		north: {
			x: 0,
			y: -1
		},
		south: {
			x: 0,
			y: 1
		},
		west: {
			x: -1,
			y: 0
		},
		east: {
			x: 1,
			y: 0
		}
	},
	getVector: function(direction){
		return this.DIRECTION_VECTORS[direction];
		if (from.x == to.x){
			if (from.y > to.y){
				return 'north';
			} else {
				return 'south';
			}
		} else {
			if (from.x > to.x){
				return 'west';
			} else {
				return 'east';
			}
		}
	}
};

module.exports = Utils;
},{}],16:[function(require,module,exports){
var UI = require('./UI.class');
var DungeonGenerator = require('./DungeonGenerator');
var Party = require('./Party.class');
var Player = require('./Player.class');
var Staff = require('./Staff.class');
var Scenario = require('./Scenario.class');
var Utils = require('./Utils');

var VirtualDungeon = {
	MOVE: 'move',
	PICK_TARGET: 'pickTarget',
	COMBAT: 'combat',
	inputStatus: null,
	levels: {},
	currentCounterId: 0,
	init: function(){
		this.scenario = new Scenario();
		this.ui = new UI(this);
		this.ui.playMusic('title');
	},
	startGame: function(){
		var config = this.ui.getNewGameConfig();
		if (error = this.getConfigErrors(config)){
			alert(error);
			return;
		}
		this.config = config;

		this.scenario.setDungeon(config.dungeon);

		this.party = new Party({
			players: config.players
		}, this);
		this.staff = new Staff({
			staffPlayers: config.staffPlayers
		}, this);
		this.party.locate(Math.floor(config.dungeonSize.w / 2), Math.floor(config.dungeonSize.h / 2));
		do {
			var level = DungeonGenerator.generateLevel({
				w: config.dungeonSize.w,
				h: config.dungeonSize.h,
				depth: config.startingLevel,
				startingLocation: this.party.location,
				roomDensity: config.roomDensity
			}, this);
		} while (!level);
		this.levels[config.startingLevel] = level;
		this.party.setLevel(level);
		this.ui.hideNewGamePanel();
		this.ui.updateRoomData();
		this.ui.initMap();
		this.setInputStatus(VirtualDungeon.MOVE);
	},
	getConfigErrors: function(config){
		if (config.players.length == 0){
			return "At least one hero is required.";
		}
		if (config.staffPlayers.length == 0){
			return "At least one dweller is required.";
		}
		if (config.staffPlayers.length < config.players.length){
			return "At least "+config.players.length+" dwellers are required.";
		}
		if (config.players.length > 4){
			return "A maximum of 4 players can play in the adventurers party.";
		}
		for (var i = 0;  i < config.players.length; i++){
			if (config.players[i].name.trim() === ''){
				return "Please provide a name for all players.";
			}
		}
		for (i = 0;  i < config.staffPlayers.length; i++){
			if (config.staffPlayers[i].name.trim() === ''){
				return "Please provide a name for all players.";
			}
		}
		return false;
	},
	move: function(dx, dy){
		this.ui.clearMessages();
		this.party.move(dx, dy);
	},
	upstairs: function(){
		this._gotoDepth(this.party.level.depth - 1);
	},
	downstairs: function(){
		this._gotoDepth(this.party.level.depth + 1);
	},
	win: function(){
		this.ui.clearMessages();
		this.ui.showMessage('You win the game!!!');
	},
	drink: function(params){
		this.ui.clearMessages();
		this.party.getPlayerByNumber(params.player).drinkFromFountain();
		this.party.getCurrentRoom().removeFeature('fountain');
		this.ui.updateRoomData();
	},
	castSpell: function(params){
		var caster = this.party.getPlayerByNumber(params.player);
		var spell = this.scenario.getSpell(params.spell);
		if (spell.targetType === 'enemy'){
			params.spellTarget = this.party.getCurrentRoom().enemies[parseInt(params.spellTargetEnemy)];
		} else if (spell.targetType === 'friend' || spell.targetType === 'friendLimb'){
			params.spellTarget = this.party.getPlayerByNumber(params.spellTarget);
		}
		caster.castSpell(spell, params);
		if (this.ui.timeFrozen){
			this.ui.toogleTimeFreeze();
		}
		this.ui.updateRoomData();
	},
	spellFailed: function(params){
		var caster = this.party.getPlayerByNumber(params.player);
		var spell = this.scenario.getSpell(params.spell);
		caster.spendMP(spell.cost);
		this.ui.updateRoomData();
	},
	_gotoDepth: function(depth){
		var level = this.levels[depth];
		if (!level){
			var config = this.config;
			do {
				level = DungeonGenerator.generateLevel({
					w: config.dungeonSize.w,
					h: config.dungeonSize.h,
					depth: depth,
					startingLocation: this.party.location,
					roomDensity: config.roomDensity
				}, this);
			} while (!level);
			this.levels[depth] = level;
		}
		this.party.setLevel(level)
		this.ui.updateRoomData(this.party.getCurrentRoom());
	},
	setInputStatus: function(inputStatus){
		this.inputStatus = inputStatus;
		switch (this.inputStatus){
			case this.MOVE:
				this.ui.enableMovement();
				break;
			case this.PICK_TARGET:
				this.ui.selectTargets(this.pickTargetCallback);
				break;
			case this.COMBAT:
				this.ui.activateCombat();
				break;
		}
	},
	passTurn: function(){
		if (this.party.getCurrentRoom().enemies.length > 0){
			this.ui.showMessage('Cannot pass while in combat!');
			return;
		}
		this.party.passTurn();
		if (Utils.chance(20)){
			this.ui.showMessage('Ambushed!');
			var enemyParty = this.staff.selectEnemyParty();
			this.party.getCurrentRoom().enemies = enemyParty;
			this.setInputStatus(this.COMBAT);
			this.ui.playMusic('combat');
		} else {
			this.setInputStatus(this.MOVE);
		}
		this.ui.updateRoomData(this.party.getCurrentRoom());
	},
	execute: function(command){
		console.log(command);
		this[command.action](command);
	},
	addCounter: function(counter){
		counter.id = ++this.currentCounterId;
		this.ui.addCounter(counter);
		var thus = this;
		setTimeout(function(){
			thus.updateCounter(counter);
		}, 1000);
	},
	updateCounter: function(counter){
		var thus = this;
		if (!this.ui.timeFrozen){
			counter.time --;
			this.ui.updateCounter(counter);
		}
		if (counter.time <= 0){
			setTimeout(function(){
				thus.ui.removeCounter(counter);
			}, 10000);
		} else {
			setTimeout(function(){
				thus.updateCounter(counter);
			}, 1000);
		}
	},
	takeItem: function(params){
		var item = this.party.getCurrentRoom().items[params.itemOnFloor];
		this.party.getCurrentRoom().items.splice(params.itemOnFloor, 1);
		this.party.addItem(item);
		this.ui.updateRoomData();
	},
	useItem: function(params){
		var item = this.party.items[params.item];
		var player = this.party.getPlayerByNumber(params.player);
		this.party.useItem(item, player);
		this.ui.updateRoomData();
	},
	openChest: function(params){
		var player = this.party.getPlayerByNumber(params.player);
		player.openChest();
		this.party.getCurrentRoom().removeFeature('chest');
		this.ui.updateRoomData();	
	},
	useEnemySkill: function(params){
		var enemy = this.party.getCurrentRoom().enemies[parseInt(params.spellTargetEnemy)];
		this.addCounter({
			time: 20,
			isBattleCounter: true,
			message: enemy.staffPlayer.name+' is recovering power',
			offMessage: enemy.staffPlayer.name+' can use skills now',
		});
		this.ui.toogleTimeFreeze();
	},
	endBattle: function(){
		this.party.getCurrentRoom().endBattle();
		this.party.cureAilment(Player.ASLEEP, true);
		this.ui.removeAllBattleCounters();
	},
	enemySleepAll: function(){
		this.addCounter({
			time: 30,
			isBattleCounter: true,
			message: 'The party falls asleep!',
			offMessage: 'The party wakes up!',
		});
	},
	enemyNegateTime: function(){
		this.addCounter({
			time: 60,
			isBattleCounter: true,
			message: 'Magic is negated!',
			offMessage: 'Magic can be used again!',
		});
	}
};

window.VirtualDungeon = VirtualDungeon;

module.exports = VirtualDungeon;
},{"./DungeonGenerator":4,"./Party.class":7,"./Player.class":8,"./Scenario.class":11,"./Staff.class":12,"./UI.class":14,"./Utils":15}],17:[function(require,module,exports){
module.exports = {
	endRooms: {
		8: {
			name: 'Final Battle',
			helpText: 'Create a boss battle scenario, if the player wins he wins the game!' 
		}


	}
}
},{}],18:[function(require,module,exports){
module.exports = {
	jobs: [
		{name: 'Bard', str: 10, magic: 10, dex: 30},
		{name: 'Druid', str: 10, magic: 20, dex: 20},
		{name: 'Mage', str: 10, magic: 30, dex: 10},
		{name: 'Paladin', str: 20, magic: 20, dex: 10},
		{name: 'Fighter', str: 30, magic: 10, dex: 10},
		{name: 'Tinker', str: 20, magic: 10, dex: 20},
		{name: 'Shepherd', str: 10, magic: 10, dex: 10},
		{name: 'Ranger', str: 15, magic: 15, dex: 20}
	],
	spells: [
		{ name: 'Awaken', cost: 1, words: 'AN ZU', description: 'Causes all Asleep members in the party to recover.', effect: 'removeAilmentFromAll', param: 'asleep' },
		{ name: 'Cure', cost: 1, words: '', description: 'Removes status ailments from a single party member (not injuries).', effect: 'removeAllAilments', targetType: 'friend'},
		{ name: 'Magic Missile', cost: 1, words: '', description: 'Causes 2 points of physical damage.', effect: 'physical'},
		{ name: 'Open', cost: 1, words: 'AN SANCT', description: 'Opens a chest content without triggering any trap.', effect: 'openChest'},
		{ name: 'Heal', cost: 3, words: '', description: 'Recovers 3 hit points and cures injury on a single body part.', targeted: true, targetType: 'friendLimb', effect: 'heal', param: 3 },
		{ name: 'Protection', cost: 3, words: 'UUS SANCT', description: 'Renders a player invincible for 10 seconds. ', targeted: true, targetType: 'friend', effect: 'counter', param: {message: 'is invincible', offMessage: 'is no longer invincible', time: 10}},
		{ name: 'Fireball', cost: 3, words: '', description: 'Causes 3 points of fire damage.', effect: 'physical'},
		{ name: 'Blink', cost: 3, words: '', description: 'Teleports the party to a nearby room in a given direction without triggering any traps. Cannot be used in battle.', effect: 'blink', targetType: 'direction'},
		{ name: 'Sleep', cost: 3, words: 'IN ZU', description: 'Causes an enemy to sleep for 30 seconds.', targeted: true, targetType: 'enemy', physicalHitCheck: true, effect: 'counter', param: {message: 'is asleep', offMessage: 'wakes up', time: 30}},
		{ name: 'Repel Undead', cost: 3, words: 'AN XEN CORP', description: 'Causes 3 points of holy damage to all undead enemies', effect: 'physical'},
		{ name: 'Peer', cost: 3, words: 'VAS WIS', description: 'Allows the caster to see the dungeon map for 5 seconds. Cannot be used in battle.', effect: 'physical'},
		{ name: 'Quickness', cost: 4, words: 'REL TYM', description: 'Make all enemies moves slowly for 10 seconds.', effect: 'counter', param: {message: 'Party moves quickly!', offMessage: 'Quickness wears off!', time: 10}},
		{ name: 'Dispel', cost: 4, words: '', description: 'Removes a fire or energy field from a corridor. Cannot be used in battle.', effect: 'removeField', targetType: 'direction'},
		{ name: 'Iceball', cost: 4, words: '', description: 'Causes 3 points of ice damage.', effect: 'physical'},
		{ name: 'Negate Magic', cost: 4, words: 'AN ORT', description: 'Prevents all magic spells for 1 minute.', effect: 'counter', param: {message: 'Magic cannot be used!', offMessage: 'Magic can be used now!', time: 60}},
		{ name: 'Kill', cost: 5, words: '', description: 'Strikes an enemy with a deadly ray of energy.', effect: 'physical'},
		{ name: 'Jinx', cost: 6, words: 'VAS AN XEN EX', description: 'Turns an enemy into an ally temporarily for 30 seconds.',targeted: true, targetType: 'enemy', physicalHitCheck: true, effect: 'counter', param: {message: 'turns into an ally', offMessage: 'is an enemy again', time: 30}},
		{ name: 'Resurrect', cost: 7, words: 'IN MANI CORP', description: 'Revives a player with 1 HP.', effect: 'revivePlayer', targetType: 'friend'},
		{ name: 'Tremor', cost: 6, words: 'VAS POR YLEM', description: 'Causes 5 points of physical damage to all non-flying enemies', effect: 'physical'}
	],
	items: [
		{ name: 'Yellow Potion', effect: 'recoverHP', param: 5}
	],
	enemies: [
		{name: 'Skeleton', from: 1, to: 2, intrisics: 'Undead'},
		{name: 'Headless', from: 1, to: 2},
		{name: 'Orc', from: 1, to: 3},
		{name: 'Rogue', from: 1, to: 3},
		{name: 'Troll', from: 2, to: 3, 
			skills: [{
				name: 'Throw Rock', 
				description: 'Causes 2 points of physical damage'
			}],
			sp: 2},
		{name: 'Lava Lizard', from: 2, to: 4, intrinsics: 'Fire Resistant', 
			skills: [{
				name: 'Fireball',
				description: 'Causes 2 points of fire damage'
			}],
			sp: 2
		},
		{name: 'Ettin', from: 2, to: 4, 
			skills: [{
				name: 'Throw Boulder',
				description: 'Causes 3 points of physical damage'
			}],
			sp: 2
		},
		{name: 'Daemon', from: 3, to: 4,
			intrinsics: 'Fire Resistant, Flying', 
			skills: [{
				name: 'Magic Missile',
				description: 'Causes 3 points of physical damage'
			}],
			sp: 3
		},
		{name: 'Cyclops', from: 3, to: 5,
			skills: [{
				name: 'Throw Boulder',
				description: 'Causes 3 points of physical damage'
			}],
			sp: 2
		},
		{name: 'Mage', from: 3, to: 5,
			skills: [{
				name: 'Magic Missile',
				description: 'Causes 2 points of physical damage'
			}],
			sp: 3
		},
		{name: 'Liche', from: 4, to: 5,
			intrisics: 'Undead',
			skills: [{
				name: 'Magic Missile',
				description: 'Causes 3 points of physical damage'
			}],
			sp: 3
		},
		{name: 'Hydra', from: 4, to: 6,
			intrinsics: 'Fire Resistant', 
			skills: [{
				name: 'Fireball',
				description: 'Causes 5 points of fire damage'
			}],
			sp: 3
		},
		{name: 'Dragon', from: 5, to: 6,
			intrinsics: 'Fire Resistant, Flying', 
			skills: [{
				name: 'Fireball',
				description: 'Causes 4 points of fire damage'
			}],
			sp: 3
		},
		{name: 'Zorn', from: 5, to: 7,
			skills: [{
				name: 'Negate',
				description: 'Stops magic for 1 minute',
				special: 'negate'
			}],
			sp: 1
		},
		{name: 'Gazer', from: 6, to: 7,
			intrinsics: 'Flying', 
			skills: [{
				name: 'Sleep',
				description: 'Puts enemies to sleep for 30 seconds',
				special: 'sleep'
			}],
			sp: 1
		},
		{name: 'Reaper', from: 6, to: 8,
			intrinsics: 'Inmobile', 
			skills: [{
				name: 'Sleep',
				description: 'Puts enemies to sleep for 30 seconds',
				special: 'sleep'
			}],
			sp: 5
		},
		{
			name: 'Balron', from: 7, to: 8,
			intrinsics: 'Fire Resistant, Flying', 
			skills: [{
				name: 'Sleep',
				description: 'Puts enemies to sleep for 30 seconds',
				special: 'sleep'
			},
			{
				name: 'Fireball',
				description: 'Causes 5 points of fire damage'
			}
			],
			sp: 3
		}
	]
};
},{}]},{},[16]);
